/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */


/**
 *
 * @author Julio Cachay
 */
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.Attributes;
import java.util.Vector;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;

public class JuegoXMLHandler extends DefaultHandler {
    /* Esto no es nuevo */
    //vector de instancias
    private Vector instancias;
    //"Juego" que se esta procesando
    private Juego actual;
    //valor contenido entre las etiquetas de un elemento
    private String valor;
    /* Esto si es nuevo */
    //Como queremos pasar el control del proceso de un
    //Handler a otro, necesitamos tener el parser para
    //asignarle el Handler que necesite en cada instante.
    private XMLReader parser;
    //Este es el Handler que procesara los personajes que
    //contenga el documento
    private PersonajeXMLHandler handlerPersonaje;

    public JuegoXMLHandler(XMLReader parser, Vector v) {
        this.parser = parser;
        this.instancias = v;
    }

    public void startElement(String namespaceURI, String localName, String qName,
            Attributes attr) throws SAXException {
        //comprobamos si empezamos un elemento "juego"
        if (localName.equals("juego")) {
        //creamos la nueva instancia de Juego
            actual = new Juego();
            //y la añadimos al Vector que las almacena
            instancias.addElement(getActual());
        } else if (localName.equals("personaje-principal")) {
            //creamos una instancia de Personaje
            Personaje principal = new Personaje();
            //se la asignamos al juego actual como principal
            getActual().setPrincipal(principal);
            /*
            y pasamos el control al Handler de personaje principal
            le tenemos que pasar el parser, para que recoga
            los datos del fichero, este Handler para que luego
            nos devuelva el control, y el personaje donde meter
            los datos que procese.
             */
            handlerPersonaje = new PersonajeXMLHandler(parser, this, principal);
            parser.setContentHandler(getHandlerPersonaje());
        }
    }

    public void endElement(String namespaceURI, String localName, String rawName)
            throws SAXException {
        /*
        miramos de que elemento se trata y asignamos los atributos
        correspondientes al "Juego" actual.
         */
        if (localName.equals("nombre")) {
            getActual().setNombre(valor);
        } else if (localName.equals("descripcion")) {
            getActual().setDescripcion(valor);
        }
        valor = null;
    }
    /*
    Los parametros que recibe es la localizacion de los carateres del elemento.
     */

    public void characters(char[] ch, int start, int end) throws SAXException {
    //creamos un String con los caracteres del elemento y le quitamos
    //los espacios en blanco que pueda tener en los extremos.
        valor = new String(ch, start, end);
        valor = valor.trim();
    }

    /**
     * @return the handlerPersonaje
     */
    public PersonajeXMLHandler getHandlerPersonaje() {
        return handlerPersonaje;
    }

    /**
     * @return the actual
     */
    public Juego getActual() {
        return actual;
    }
}