/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */


/**
 *
 * @author Julio Cachay
 */
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;

public class PersonajeXMLHandler extends DefaultHandler {
    //valor contenido entre las etiquetas de un elemento
    private String valor;
    //El parser, para luego devolver el control al
    //Handler de juego.
    private XMLReader parser;
    //El Handler al que queremos volver
    private JuegoXMLHandler handlerJuego;
    //EL personaje donde meter los datos que leamos.
    private Personaje personaje;

    public PersonajeXMLHandler(XMLReader parser, JuegoXMLHandler handler,
            Personaje personaje) {
        this.parser = parser;
        this.handlerJuego = handler;
        this.personaje = personaje;
    }

    public void endElement(String namespaceURI, String localName, String rawName)
            throws SAXException {
        /*
        miramos de que elemento se trata y asignamos los atributos
        correspondientes a el "Personaje" actual o devolvemos el control
        al Handler de juego.
         */
        if (localName.equals("nombre")) {
            getPersonaje().setNombre(valor);
        } else if (localName.equals("habilidad")) {
            getPersonaje().setHabilidad(valor);
        } //si hemos llegado al final de la etiqueta
        else if (localName.equals("persona-contacto")) {
            parser.setContentHandler(handlerJuego);
        }
        valor = null;
    }
    /*
    Los parametros que recibe es la localizacion de los carateres del elemento.
     */

    public void characters(char[] ch, int start, int end) throws SAXException {
    //creamos un String con los caracteres del elemento y le quitamos
    //los espacios en blanco que pueda tener en los extremos.
        valor = new String(ch, start, end);
        valor = valor.trim();
    }

    /**
     * @return the personaje
     */
    public Personaje getPersonaje() {
        return personaje;
    }
}